#ifndef MODEL_H
#define MODEL_H

#include <list>
#include "MyVector.h"
#include "Edge.h"
#include <iostream>
#include <vector>

#define FLT_MIN 1.1754E-38F
#define FLT_MAX 1.1754E+38F
#define PIECE_SCALE 1

struct Face {
   int v1;
   int v2;
   int v3;
   MyVector mNormal;
   Face(int in_v1, int in_v2, int in_v3) : v1(in_v1), v2(in_v2), v3(in_v3), mNormal(0, 1, 0){}
   Face() : mNormal(0, 1, 0) {v1 = 0; v2 = 0; v3 = 0;}
   Face(Face &f) {v1 = f.v1; v2 = f.v2; v3 = f.v3; mNormal = f.mNormal;}
   bool contains(int);
};

class Model {
public:
   Model() {}
   Model(char *);
   Model *Clone();

   std::vector<Face *> mFaces;
   std::vector<MyVector *> mVertices;
   std::vector<MyVector *> mNormals;
   std::vector<std::vector<Edge> > *mEdges;
   size_t mNumEdges;
   MyVector mCenter;

   float max_x, max_y, max_z;
   float min_x, min_y, min_z;
   float max_extent;

protected:
   void ReadStream(std::istream &);
   void ReadLine(char *);
   void ReadFile(char *);
};

#endif