#include "MyVector.h"
#include <math.h>

float MyVector::Dot(MyVector &v)
{
   return (x*v.x + y*v.y +z*v.z);
}

MyVector MyVector::CrossProd(MyVector &v)
{
   return MyVector(y*v.z - z*v.y, z*v.x - x*v.z, x*v.y - y*v.x);
}

MyVector MyVector::Minus(MyVector &v)
{
   return MyVector(x - v.x, y - v.y, z - v.z);
}

MyVector MyVector::Plus(MyVector &v)
{
   return MyVector(x + v.x, y + v.y, z + v.z);
}

MyVector MyVector::Scale(float scale)
{
   return MyVector(x * scale, y * scale, z * scale);
}

void MyVector::Norm()
{
   float mag = Mag();

   x /= mag;
   y /= mag;
   z /= mag;
}

float MyVector::Mag()
{
   return sqrt(x*x + y*y + z*z);
}